Source Code Control Reference

See Also Tasks

[This topic is under construction.]


Source Code Control Concepts

The Microsoft development environment (for Visual J++ and Visual InterDev) integrates source control commands and functions into the Project Explorer (and other menus and windows). You can use source control to manipulate source file (item) locations and versions, set up your source control project hierarchy to match your development directory tree, and more effectively manage team projects by delaying additions, deletions, and renames to the source control database.

Note The examples in this section refer to Visual SourceSafe as the default source code control application. If you are using Visual InterDev for source code control, please see the Visual InterDev topics Source Control or Working with Multiple Developers. If you are using another source code control system, please see your source code control provider for more information.

The following sections provide information to acquaint you with source code control in the Microsoft development environment:

Section | Description
What is Source Code Control? | Gives a brief overview of using the features of source control and the development environment together.
Setting Up Source Code Control with the Microsoft Development Environment | Briefly describes the first steps to integrating the Microsoft development environment with your Visual SourceSafe database.
Different Project Models in Source Code Control | Compares directory-based and reference-based project systems, describing how the differences impact source code control.
Overview of Pushing or Pulling Changes to Source Code Control | Introduces a means to selectively defer updates to local or database files.


What is Source Code Control?

With source control systems, you use a database to track, organize, and manage "projects." These projects are a unit of organization, like a folder, and can contain various kinds of files (items), including code and documentation. This version control enables you to more flexibly manage the contents of projects (for example, to include only items labeled as a "release" version of the application) and manage project history (to restore an older version, for example, for testing or re-release). Some features are available only in the Microsoft development environment; some features are specific to Visual SourceSafe only. This section describes what you can do with each feature set and what you can do using them together.

With Visual SourceSafe and the Microsoft development environment, you can:

  • Control all the projects and solutions in one central database for your team to access.

  • Use the basic source control commands directly in the Project Explorer (in the development environment).

  • View the history of a source control project.

  • Share the same item among many source control projects (without making copies of it everywhere).

  • Branch an item to create a unique copy of another item (in Visual SourceSafe).

  • Merge two versions of the same item together (in Visual SourceSafe).

Controlling All the Projects and Solutions In One Central Database

A typical source code control configuration assumes that all the files are kept in one master source code control database on a server, linked to the developers' computers by a network link. The master database is where you store the original information, such as code and documentation, and the individual computers are where you edit and compile the files. With a central location of the files for your team, you can better control the access to the files and the organization of the project tree.

Using the Source Control Commands in the Project Explorer

The Microsoft development environment integrates the basic commands and functions of Visual SourceSafe directly into the Project Explorer for ease of use. The development environment also tracks the status of the projects and solutions to aid with renaming, adding, and deleting files to Visual SourceSafe.

You can maintain the files and code in the master source control database through these four basic commands, available in the Project Explorer (in the development environment):

  • Get Latest Version

    The Get Latest Version command retrieves the most current copy of the item from the master source control server and copies it to the local machine. The item is still read-only. For step-by-step instructions, see Getting the Current Version of a File.

  • Add to Source Control

    You can Add to Source Control the project or solution shown in the Project Explorer (in the development environment). This sends a copy of the files to the master source control database you specify in the Visual SourceSafe project tree. For step-by-step instructions, see Adding a Project or Solution to Source Control.

  • Check Out

    The Check Out command retrieves the latest version of the item from the master source code control database and reserves that item to the local user who is checking it out. For step-by-step instructions, see Checking Items In and Out.

    In Visual SourceSafe, you can set the check out option to exclusive (one person at a time) or multiple (check out one item to many people at once). The default setting is exclusive check out. This avoids many editing conflicts when checking the item back in.

  • Check In

    The Check In command copies a local item to the master database, adding the latest version. For step-by-step instructions, see Checking Items In and Out.

Viewing the History of a Project

You can see the history of a source control project through the History command in the development environment. This tells you when the latest changes were made, and by whom, and what happened to the item each time it was checked in, since it was first created. For step-by-step instructions, see Viewing the History of a Source Control Item.

Sharing Files

You can share an item across more than one source control project (Visual SourceSafe only). When you update one copy of the shared file, all copies reflect the new changes. The shared item is stored only once in the Visual SourceSafe database, with pointers to the item in the other projects. For step-by-step instructions, see Sharing a Project.

This method makes it possible to share common components across several different projects. Keep in mind that source control systems can store any kind of item — including code, documentation, stored procedures, and HTML items.

Branching Shared Files

Branching is feature specific to Visual SourceSafe. You can branch a project in source control by sharing a project to an additional location in your source control project tree. When the project is shared, you can choose to branch the project, and the connection to the duplicate project is broken, so that changes are no longer updated from the other shared projects.

You can use the Change Location command in the development environment to point your local project to the new location of the project in source control. This feature is useful for creating a special version of a common file, for creating separate versions for language differences, or for customizing an application. You can also use this feature to branch files of a specific version of the finished application.

Merging Versions Together

You can put two versions of the same item together with the merge feature (available only in Visual SourceSafe). This feature displays the two versions of the items side by side in Visual SourceSafe, and you reconcile the changes you want to keep in the final version of the item.

Merging versions is useful if the multiple checkout feature in Visual SourceSafe is enabled. This is also useful when updating changes to a branched item.


Setting Up Source Control with the Microsoft Development Environment

Once you set up Visual SourceSafe, you can perform several steps to integrate it with the Microsoft development environment. With this integration, you can use the environment to track item versioning, renaming, deleting, and more. First steps to integrating the development environment with your Visual SourceSafe database include:

  • Installing the server or client Visual SourceSafe applications to set up your master source code control database.

  • Finding or connecting with the Visual SourceSafe database.

  • Mirroring your development directory tree in Visual SourceSafe's project structure for ease of use.

  • Adding projects or solutions to the master source control database.

Choosing the Client or Server Installation of Visual SourceSafe

When you first install Visual SourceSafe, you have two options:

  • Server Installation

  • Client Installation

The server installation is performed once by the administrator of your network. This creates the server's source code control database, to be used by all of your team. The administrator can then add users with the administrator application. (The administrator also needs to install the client application of Visual SourceSafe to the server to use Visual SourceSafe.)

The client installation is for all the local machines that are going to access the master source code control database. The database server itself also needs to include the client installation if the administrator wishes to run Visual SourceSafe and access the files on that machine. The client application works with development environment to give you access and control over your source control files.

The administrator can setup Visual SourceSafe to provide a way for local users to install the client application over the network from the server's location. This process, called netsetup, provides the database location information to the client application.

When you install Visual SourceSafe, select the "IDE Integration Option" to incorporate the Microsoft development environment. For more information on installing Visual SourceSafe, see the Visual SourceSafe documentation.

Finding or Connecting with the Visual SourceSafe Database Server

You may want to re-establish a connection with the source code control database because you:

  • Need to find the initial connection to the source control database.

  • Have lost the network connection to the source code control server.

  • Want to change the Visual SourceSafe project in which you're working (or your Visual SourceSafe project was moved or renamed).

  • Must work offline on a separate computer or laptop (assuming you already have an established connection with the source control database).

If you need to find the initial connection to your source control database, see Connecting to the Source Control Database for more information and step-by-step instructions.

In the next two cases, if you need to reconnect to the source code control database, you can use the Change Location command on the development environment Project menu (in the Source Control submenu) to change the connection.

If the name of your database project changes, you can use the Change Location command to link your local copy of source code control with the current source control server.

If you must work offline, you can Check Out the items you want (or Get the latest versions) and then go offline. This feature disables any further messages about a lost connection with the source control server. When you reconnect, you can change this to online and Check In your files.

Mirroring Your Development Directory Tree in Visual SourceSafe's Project Structure

A typical source code control network assumes that all the files are kept in one master source code control database on a server, linked to the developers' computers by a network link. The master database is where you store the original information, such as code and documentation, and the individual computers are where you edit and compile the files.

Your hard drive is organized into a directory tree, usually with a root directory labeled c:\ and folders or subdirectories such as c:\res\icons. The Visual SourceSafe database is organized in a very similar manner — in a project tree. The project root is labeled $/ and it can contain subprojects such as $/Resources/Icons. Visual SourceSafe projects and subprojects are organized similar to the directories or folders on your machine's hard drive.

When you work on a project in Visual SourceSafe, you associate a local directory path name, or Working Folder, with that project (this is known as the "working directory" for the project). This local directory path name, such as D:\projects\proj1\res\icons, can mirror the structure of Visual SourceSafe project, $/Project1/Resources/Icons. This path name can be customized for each user and loosely correlates with the Visual SourceSafe project. Another developer can set up their own machine to access the same Visual SourceSafe project with a local directory path of C:\projects\proj1\graphics, and point to $/Project1/Resources/Icons.

If you are just starting out with Visual SourceSafe, a good strategy is to map the project layout in the source code control database to mirror the names and hierarchy of the usual development directory tree. This makes the associations recognizable. You can add shared files and branching later. The development environment will populate the directory tree from the solution when you first check in the solution.

Adding Projects or Solutions to the Source Control Database

You can add projects or solutions through the development environment with the Add to Source Control command. When you add a solution to source code control, all the projects in that solution can be added as well. This is useful when you have a large number of projects to add to source control at once.

The first time you open a project in source control, you use the New Project command (on the File menu) and click Source Control to get to the database. Afterward, the development environment remembers the location of the database for you.

When you first join a team which is working on a source control project, you need to get current copies of all the source control files used by your team. To retrieve copies of the files from the database to your local machine, Open the project and click Source Control. You can use the Get command to retrieve the latest copies of the files to your local machine.

Visual SourceSafe supports a "branch" (forking) function, where you create a new version of a project. This command cannot be performed from within the development environment (only within Visual SourceSafe). However, if you do branch a project, the development environment's last known location for the project will not match the new location. To resolve this, you should use the Change Connection command to modify the source control connection for the projects in the solution, and check that in immediately. Other people can then use Open Project (Source Control menu) to open the new project.


Using Source Code Control with Two Models of Projects

Different Project Models in Source Code Control

When working in the Microsoft development environment, you are using one of two kinds of projects: reference-based or directory-based. These distinctions are not presented as categories within the environment, but they influence how your projects will be treated in source control tasks.

The reference-based project is similar to a Visual Basic or Visual C++ project, in that it uses a project file to list and track files contained in the project, source code control information on those files, and other data. These project files may be physically located anywhere on the developer's system. Examples of a reference-based project (in the development environment) include Utility Projects or Database Projects.

The directory-based project is similar to a Visual J++ project, uses the directory that holds the project to define the list of files to build for that project. The directory-based project contains a project file but does not use that file as its only method of defining the list of files and their respective locations. All files in a directory-based project must be in the project's root directory or a sub-directory of the project's root directory.

The following table lists and compares characteristics of these two project models:

Reference based projects | Directory-based projects
You use the project file as the current list of files to build. This is also how a reference-based project tracks dependency files for builds. | You use the actual presence of the files in the specified directory as the current list of files in a project (along with maintaining a file list in the project file).
You track source code control issues in the project file. | You track source code control issues by altering directory contents.
Only files you choose in your settings for your build configuration are included in builds. | You can choose files to drop out of the build in the Project Explorer by excluding them from the project. This will not delete the files but make them appear a lighter gray in the display.
You can build multiple projects that reference a single item in one location. | You must keep a separate copy of an item in a different directory for each project in which it builds.
You can keep files in the directory that are not part of the project. | You only include files that are completed and built in the directory. The files in progress are kept locally.
You can have placeholder or incomplete (or not built) files in the directory. | All files in the project directory will be built. Use the Exclude feature in the Project Explorer to ensure that the project contains only files that can be built.
A project can span subdirectories. You can use this to sort file types, possibly storing core files in one directory, user interface files in another, and so on. The project's files may be anywhere on the developer's system. | Each project is completely contained within its directory or a subdirectory of the project's root directory.
Multiple projects can be located in the same directory. | One project is contained in a given directory.
Only files referred to in the project file will be synchronized with source code control. | Files contained in the project directory are included in the next build after you synchronize with source code control.
When moving files, file paths must be updated in the project file. | No absolute path names in the project file, so the project can be moved as an entire unit, by moving the entire directory.


Overview of Pushing or Pulling Changes to Source Code Control

Source control systems typically allow you to work on a project locally without affecting the work of other team members. However, some operations (such as add, delete, and rename) traditionally have required you to synchronize your local work immediately with other team members, or to remember to synchronize at the same time as you check in.

With the development environment and Visual SourceSafe together, you can:

  • Control when changes you make to an item are checked into the master source control database.

  • Develop strategies for delaying changes to or from source control.

You can delay changes locally until the all files are changed and/or working together. As you use source code control, the Microsoft development environment can remind you of incomplete actions or delay changes to your local solution.

Controlling When Your Changes Affect the Source Control Project

You can delay three basic source control actions (adding, renaming, and removing). These actions can be delayed for indeterminate amounts of time. Source control actions can go two ways — from the server to the local machine or to the server from the local machine.

You can delay these changes by clicking Remind on certain dialog boxes. Later you are prompted about the item, and you can send it on or delay it again. This can continue indefinitely, but the longer you delay a change to source control, the higher the probability for merge changes or other problems.

The initial dialog boxes that delay or remind you on these changes to source control appear according to certain actions, called pushing or pulling. Pushing an item refers to sending a copy of the changed item to the source control server from the local machine. Pulling an item refers to retrieving a copy of the changed item from the source control server to the local machine. The dialog boxes appear when an item is on one location, your local machine and not the other, the source control server (or vice versa).

The dialog boxes that remind you of the delayed actions occur, by default, whenever a project item is pushed or pulled. Pushing actions include Check In and Add to Source Control. Pulling actions include Get Latest, Check Out, and Undo Check Out. You can change the timing of these reminder dialog boxes to appear all the time or not at all. For step-by-step instructions on how to set the timing of the reminders, see Changing the Timing of Reminder Dialog Boxes.

Strategies for Delaying Files to Source Control

You can delay adding a file, deleting a file, or renaming a file. This keeps your changes in the source control database from affecting your local files until you are ready. Depending on whether you are working with reference- or directory-based projects, you should employ a strategy that makes the most of the project model.

One strategy for directory-based projects is to check in the item initially, when it is created, so the name of the item is reserved in source control. You can then hold the item checked out locally while you work on it until you think that the item is ready to build. Before building, you can check in the item with the new version of the item ready to build available to the team.

For reference-based projects, the buildable state of the files in the source control database is not as critical, since the builds specify which files are to be used, instead of pulling all the files from a directory by default. The delaying tactics here become a good idea for testing and initial work in roughing out the content in the file.

CAUTION Delaying changes to source code control for too long — especially if the source control database has other incomplete rename or delete actions with the same item — can lead to complicated situations and an unknown state of your file. Don't forget that source code control is intended to hold different versions of the item in a central location so you can restore a prior version if necessary.


This topic is under construction.


Source Code Control User Interface Reference

Tasks Related Topics

The Microsoft development environment integrates source control systems (such as Visual SourceSafe) into the Project Explorer and other menus and windows. The following dialog boxes assist in source control tasks:

Add Conflicts with Deferred Delete Dialog Box

Add Conflicts with Deferred Rename Dialog Box

Add to Source Control Dialog Box

Check In Items Dialog Box

Check Out Items Dialog Box

Check Out for Editing Dialog Box

Check Out for Save Dialog Box

Conflicting Modifications Detected Dialog Box

Defer Source Control Operation Dialog Box

Get Latest Version Dialog Box

Incomplete Deletion Conflicts with Added Item Dialog Box

Incomplete Rename of Added Item Dialog Box (I)

Incomplete Rename of Added Item Dialog Box (II)

Pull Added Items From Server Dialog Box

Pull Removed Items From Server Dialog Box

Push Add to Server Dialog Box

Push Remove to Server Dialog Box

Push Remove to Server (Incomplete Rename) Dialog Box

Push Rename to Server Dialog Box

Reminder to Push Add to Server Dialog Box

Reminder to Push Remove to Server Dialog Box

Reminder to Push Rename to Server Dialog Box

Remove Items From Source Control

Rename Item in Source Control Dialog Box

Set Source Control Connection Dialog Box

Source Control (Environment - Options Dialog Box)

Specify Working Directory Dialog Box

Undo Check Out Dialog Box


Add Conflicts With Deferred Delete Dialog Box

Use this dialog box to resolve a delayed action that is interfering with your adding items to the source control server. The items you deleted locally were not deleted on the source control server (the deleting action was delayed). These deleted items match names with the items you are trying to add now.

Options

Items

Displays a list of the items that are in conflict with your current action, adding an item to source control. The items listed were deleted locally, but not deleted on the source control server. The names of these locally deleted items match the names of the items you are trying to add to the source control server.

Push Delete

Deletes from the source control server the items listed in the Items box. Afterward, you will be prompted to continue with your original action to add items.

Allow Conflict

Proceeds with the source control action, which may overwrite or change the items listed in the Items box. This action ignores any delayed actions that were not pushed to the server. Also, since you are ignoring this delayed action, the development environment will no longer keep a record of it. Next, you will be prompted to complete adding items to source control.


Add Conflicts With Deferred Rename Dialog Box

Use this dialog box to resolve a situation that is blocking you from adding items to source control. The items you renamed locally were not renamed on the source control server (the renaming action was deferred). These renamed items match names with the items you are trying to add now.

Options

Items

Displays a list of the items that are in conflict with your current action. These items were renamed locally, but not renamed on the source control server. The source control database names for these items match the names of the items you are trying to add to the source control server.

Push Rename

Renames the source control server items to match the list in the Items box. Afterward, you will be prompted to continue with your original action to add items.

Allow Conflict

Proceeds with the source control action, which may overwrite or change the items on the source control server. These items are listed by their local names in the Items box. This action ignores any delayed actions that were not pushed to the server. Also, since you are ignoring this delayed action, the development environment will no longer keep a record of it. Next, you will be prompted to complete adding items to source control.


Add Files to Source Code Control Dialog Box

Add to Source Code Control Dialog Box

Tasks Related Topics

Use this dialog box to add solutions, projects, or individual items to source control. Items marked with a check mark in the Items box are added to the source control server.

Options

Items

Displays a list of the items based on your current selection in the Project Explorer (in the development environment). Select the box next to the items you wish to add to source control and check mark appears next to the item. You can click Check All to select all the items at once.

This box displays the first level of folders and contents; to see additional items contained within sub-folders, click Recurse. Items contained within a sub-folder are not added to source control unless they are displayed individually in the Items box and selected with a check mark.

Recurse

Forces items to be displayed in sub-folders or sub-directories in the Items box. You can then select these items for source control actions.

By default, the Items box displays only the first level of items contained in the Project Explorer for the development environment. Clicking Recurse displays all the subfolders and all their items for any remaining levels in the directory tree. You can then select additional items for actions in source control.

Keep Checked Out

Refreshes the source control server with the latest version of the local items that are selected, but keep the item checked out to you.

Don’t Show any more Add dialogs

Suppresses any more instances of the Add to Source Control dialog boxes. Add to Source Control becomes a direct command on the environment menus. You will not be able to add Comments or use Advanced options until you enable these dialog boxes again.

You can enable the dialog boxes again by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Comment

Enter any comments about the item here. You can type up to 4,095 characters.

Check All

Selects with a check mark all the items visible in the Items box. To see additional subfolders and levels of items, click Recurse. Only items that are visible in the Items box and are shown with a check mark are added to source control.

Advanced

Displays more options on adding to source control. Your source control program supplies these options.


Check In Items Dialog Box

Tasks Related Topics

Use this dialog box to check in solutions, projects, or individual items from your local machine to the source control server. Items marked with a check mark in the Items box are checked in to the source control server.

Checking in an item copies the current version of the local item you’re working on to the source control server. This action also unlocks the item on the source control server, so that the item is available to check out by other people.

Options

Items

Displays a list of the items based on your current selection in the Project Explorer (in the development environment). Select the box next to the items you wish to check in to source control and check mark appears next to the item. You can click Check All to select all the items at once.

This box displays the first level of folders and contents; to see additional items contained within sub-folders, click Recurse. Items contained within a sub-folder are not checked in to source control unless they are displayed individually in the Items box and selected with a check mark.

Recurse

Forces items to be displayed in sub-folders or sub-directories in the Items box. You can then select these items for source control actions.

By default, the Items box displays only the first level of items contained in the Project Explorer for the development environment. Clicking Recurse displays all the subfolders and all their tems for any remaining levels of depth in the directory tree, as shown in the Project Explorer. You can then select additional items for actions in source control.

Keep Checked Out

Refreshes the source control server with the latest version of the local items that are selected, but keep the item checked out to you.

Don’t show any more Check In dialogs

Suppresses any more instances of the Check In to Source Control dialog boxes. Check In to Source Control becomes a direct command on the environment menus. You will not be able to add Comments or use Advanced options until you enable these dialog boxes again.

You can enable the dialog boxes again by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Comment

Enter any comments about the item here. You can type up to 4,095 characters.

Check All

Selects with a check mark all the items visible in the Items box. To see additional subfolders and levels of items, click Recurse. Only items that are visible in the Items box and are shown with a check mark are checked in to source control.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.

Differences

Displays a comparison of this item version with previous versions of the item. Your source control program supplies these comparisons.


Check Out Items Dialog Box

Tasks Related Topics

Use this dialog box to check out solutions, projects, or individual items from source control. Items marked with a check mark in the Items box are checked out from the source control server.

Checking out an item copies the current version of the item from the source control server to your local machine. This action also locks the item on the source control server, so that the item is read-only (unless your source control is configured to do multiple checkouts).

Options

Items

Displays a list of the items based on your current selection in the Project Explorer (in the development environment). Select the box next to the items you wish to check out from source control and check mark appears next to the item. You can click Check All to select all the items at once.

This box displays the first level of folders and contents; to see additional items contained within sub-folders, click Recurse. Items contained within a sub-folder are not checked out from source control unless they are displayed individually in the Items box and selected with a check mark.

Recurse

Forces items to be displayed in sub-folders or sub-directories in the Items box. You can then select these items for source control actions.

By default, the Items box displays only the first level of items contained in the Project Explorer for the development environment. Clicking Recurse displays all the subfolders and all their items for any remaining levels of depth in the directory tree, as shown in the Project Explorer. You can then select additional items for actions in source control.

Don’t show any more check out dialogs

Suppresses any more instances of the Check Out Items dialog boxes. Check Out From Source Control becomes a direct command on the environment menus. You will not be able to add Comments or use Advanced options until you enable these dialog boxes again.

You can enable the dialog boxes again by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Comment

Enter any comments about the item here. You can type up to 4,095 characters.

Check All

Selects with a check mark all the items visible in the Items box. To see additional subfolders and levels of items, click Recurse. Only items that are visible in the Items box and are shown with a check mark are checked out from source control.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Check Out For Editing Dialog Box

Use this dialog box to set the behavior of the development environment when you start editing an item that you did not check out first. When you click OK, items marked with a check mark in the Items box are checked out from the source control server in this instance.

Options

Items

Displays a list of the items that are in conflict with your current action. Click the box next to the items you wish to check out from source control. A check mark appears next to the item. You can click Check All to select all the items at once.

Don’t show any more check out for edit dialogs

Suppresses any more instances of the Check Out For Editing dialog box. If you suppress the dialog box, when you are editing an item that is not checked out, the development environment beeps and checks the item out for you (without prompting).

You can enable the dialog boxes again by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

  • Always Check Out — Choose this if you would like the development environment to always check out the item from source control. This means that if you edit items in the development environment, you will not be prompted, and the environment will beep and check out the item. You may also lose a keystroke while this action is performed. The editor or window you are in may change to accommodate the change in item status.

  • Always do nothing — Choose this if you would like the default behavior of the development environment to leave the item local and not check it out from source control. This means that as you edit items in the development environment, you will not be prompted to check out an item. If you edit the local item, it will contain different information than the copy in the source control database.

Comment

Enter any comments about the item here. You can type up to 4,095 characters.

Check All

Selects with a check mark all the items visible in the Items box. To see additional subfolders and levels of items, click Recurse. Only items that are visible in the Items box and are shown with a check mark are checked out from source control.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Check Out for Save Dialog Box

Use this dialog box to preserve the changes you made to the item and perform any simultaneous source control action. Otherwise, you might be prompted about the item you are editing being read-only and not checked out from source control.

You can save these changes in the source control copy of the item by checking that item out from source control in this dialog box. Items marked with a check mark in the Items box are checked out from the source control server and the changes saved to that item.

If you do not want to save your changes to this item, do not check the item out from source control.

Options

Items

Displays a list of the items that are not checked out of source control. Click the box next to the items you wish to check out from source control. A check mark appears next to the item.

Comment

Enter any comments about the item here. You can type up to 4,095 characters.

Check Out

Checks out the items selected in the Items box. Your changes to these items are preserved if you save this item and check the item back into source control.

Save As

Saves the item you are currently modifying with a different name.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Conflicting Modifications Detected Dialog Box

Use this dialog box to finish a File Save action. While trying to save the item, the development environment found two copies of the item with the same name but differing contents. You can specify what resolution to take or click Cancel to temporarily postpone the resolution. If you cancel, you can investigate the situation. You will be prompted to resolve this situation again if you cancel now.

Options

Save As

Saves with a different name the item you are currently modifying. This item is then labeled differently from the other item the development environment found (same name, different content).

Overwrite

Proceeds with the save action, which may overwrite or change the items listed in the Items box on the source control server. This finishes the File Save action.

Cancel

Cancels the entire File Save action and this dialog box so that you can examine the items in question.


Defer Source Control Operation Dialog Box

Use this dialog box to finish or delay a source control pull action (Check Out, Undo Check Out, or Sync). While trying to perform this action, the development environment found the items listed to be in danger of possible overwriting with the server copies because the development environment cannot reload the items at this time. Consider delaying the source control action until you are done working on this solution and close it.

Options

Items

Displays a list of the items that are in conflict with your current action. Copies from the source control server may overwrite these items unless you delay this source control action.

Defer

Delays the pull action (Check Out, Undo Check Out, or Sync) until you close the current solution. The development environment completes the source control pull action automatically when the solution is closed. When you open the solution again, the items will be synchronized.

Skip

Skips over the items listed in the Items box for this source control action. Only the items listed in this Items box are skipped, not all the possible items in the source control "pull" action (this can be Check Out, Undo Check Out, or Sync).

Pull Action Now

Performs the source control pull action (Check Out, Undo Check Out, or Sync) now, possibly overwriting those items listed in the Items box with copies from the source control server.

Cancel

Aborts the entire source control "pull" action (Check Out, Undo Check Out, or Sync).


Get Latest Version Dialog Box

Tasks Related Topics

Use this dialog box to retrieve a read-only copy of solutions, projects, or individual items from source control. Items marked with a check mark in the Items box are copied from the source control server.

Get Latest Version places a copy of the requested item or items in the local copy of the solution.

Options

Items

Displays a list of the items based on your current selection in the Project Explorer (in the development environment). Select the box next to the items you wish to get from source control and check mark appears next to the item. You can click Check All to select all the items at once.

This box displays the first level of folders and contents; to see additional items contained within sub-folders, click Recurse. Items contained within a sub-folder are not retrieved from source control unless they are displayed individually in the Items box and selected with a check mark.

Recurse

Forces items to be displayed in sub-folders or sub-directories in the Items box. You can then select these items for source control actions.

By default, the Items box displays only the first level of items contained in the Project Explorer for the development environment. Clicking Recurse displays all the subfolders and all their items for any remaining levels of depth in the directory tree, as shown in the Project Explorer. You can then select additional items for actions in source control.

Directories

Shows all the directories of all the items in your current selection. You can use the Recurse box to show additional items in the directories.

Don’t show any more Get dialogs

Suppresses any more instances of the Get Latest Version dialog boxes. Get Latest Version becomes a direct command on the environment menus. You will not be able to add Comments or use Advanced options until you enable these dialog boxes again.

Get items from subdirectories

Shows all the items in the directories that you selected (checked) in the Items box. You can use this with Recurse and Directories to find items that are not directly nested in your project or not visible in the Project Explorer.

Check All

Selects with a check mark all the items visible in the Items box. To see additional subfolders and levels of items, click Recurse. Only items that are visible in the Items box and are shown with a check mark are retrieved from source control.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Incomplete Deletion Conflicts with Added Item Dialog Box

Use this dialog box to resolve a situation that is interfering with your adding items to the local project or solution. The items you deleted locally were not deleted on the source control server (the deleting action was deferred). These deleted items match names with the items you are trying to add locally now.

Options

Items

Displays a list of the items that are in conflict with your current action. These items were deleted locally, but not deleted on the source control server. The names of these locally deleted items match the names of the items you are trying to add to the local project or solution.

Push Delete

Deletes from the source control server the items listed in the Items box. Afterward, you will be prompted to continue with your original action to add items locally.

Skip Add

Cancels the entire Add to Source Control action and ignores the outstanding delete items. The development environment will no longer keep a record of the deleted items (that were not deleted on the source control server).


Incomplete Rename of Added Item Dialog Box (I)

Use this dialog box to resolve a situation that is interfering with your adding items to the source control server. The items you renamed locally were not renamed on the source control server (the renaming action was deferred). These deferred items (using the outdated names) match the names of the items you are trying to add now.

Options

Items

Displays a list of the items that are in conflict with your current action. These items were renamed locally, but not renamed on the source control server. The outdated names of these items match the names of the items you are trying to add to the source control server.

Push Rename

Renames the list in the Items box on the source control server to match the local names. Afterward, you will be prompted to continue with your original action to add items.

Skip Add

Cancels the entire Add to Source Control action and ignores the outstanding renamed items. The development environment will no longer keep a record of the items that were only renamed locally. The source control server will not reflect the new names.


Incomplete Rename of Added Item Dialog Box (II)

Use this dialog box to resolve a situation that is interfering with your adding items to the source control server. The items you renamed locally were not renamed on the source control server (the renaming action was deferred). The outdated names of these items match the names of the items you are trying to add now.

Options

Items

Displays a list of the items that are in conflict with your current action. These items were renamed locally, but not renamed on the source control server. The outdated names of these items match the names of the items you are trying to add to the source control server.

Push Rename

Renames items in the Items box on the source control server to match the local names. Afterward, you will be prompted to continue with your original action to add items.

Skip Add

Cancels the Add to Source Control action for the items listed and ignores the outstanding renamed items. Only the items listed in the Items box are skipped, not all the possible items in your original Add to Source Control action.

Add Anyway

Proceeds with the Add to Source Control action, which may overwrite or change the items listed in the Items box. This action ignores any delayed actions that were not pushed to the server. Also, since you are ignoring this delayed action, the development environment will no longer keep a record of it.


Pull Added Items From Server Dialog Box

Use this dialog box to control when an item is added to your local machine from the source control server. The Items box lists the items that were added to the source control server. You can add these items to your local machine or delay the action.

If you delay the addition, the development environment will remind you that there is a deferred addition to your local machine. You can also choose to do nothing, and keep the added item on the source control server only, with no affect to the local machine.

Options

Items

Displays the new items from the source control server. Click the box next to the items you wish to add to your local machine, based on the button you choose (Add now, Remind later, or Do nothing). A check mark appears next to the selected item.

Add Now

Adds the items checked in the Items box. This action pulls the server copy of the added item from source control server to the local machine so that the contents of the solution will match in both places.

You will be reminded later about adding any items you did not select in the Items box (unchecked items).

Remind Later

Delays adding the items to the local machine until you are reminded. To select specific items to add to the local machine from the server, click the specific items to add, then click Add Now.

Pull reminders occur when a project is pulled. Pull actions include Get Latest, Check Out, and Undo Check Out. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all the items as they are in both places. This means that source control server's copy of the item is not added to the local machine. You will not be prompted with any more reminders.

Don’t show pull reminder dialog boxes

Select this check box to suppress any more instances of the Pull Added Items From Server dialog boxes. You will not be able to add Comments or use Advanced options until you enable these dialog boxes again.

You can enable the dialog boxes again by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Pull Removed Items From Server Dialog Box

Use this dialog box to control when an item is removed on your local machine to match a removal on the source control server. The Items box lists the items that were removed from the source control server. You can remove these items from your local machine or delay the action.

If you delay the removal, the development environment will remind you that there is a deferred removal of items not reflected on your local machine. You can also choose to do nothing, and keep the items on your local machine that were removed on the source control server.

Options

Items

Displays the items removed from the source control server. Click the box next to the items you wish to remove from your local machine, based on the button you choose (Remove now, Remind later, or Do nothing). A check mark appears next to the selected item.

Remove Now

Removes the items checked in the Items box. This action removes the local copy of the items so that the contents of the solution will match in both places.

You will be reminded later about adding any unselected items in the Items box (unchecked items).

Remind Later

Delays removing the items from the local machine until you are reminded. To select specific items to remove from the local machine, click the items to remove, then click Remove Now.

Pull reminders occur when a project is pulled. Pull actions include Get Latest, Check Out, and Undo Check Out. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Do Nothing

Leave all the items on the local machine. This means that local copy of the item, removed on the source control server, is not removed from the local machine. You will not be prompted with any more reminders.

Don’t show pull reminder dialog boxes

Select this check box to suppress any more instances of the Pull Removed Items From Server dialog boxes. You will not be able to add Comments or use Advanced options until you enable these dialog boxes again.

You can enable the dialog boxes again by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Push Add To Server Dialog Box

Use this dialog box to control when an item is added to the source control server from your local machine. The Items box lists the items that were added to the local machine. You can add these items to the source control server or delay the action.

If you delay the addition, the development environment will remind you that there are added items that are not pushed to the source control server. You can also choose to do nothing, and keep the added items on your local machine only.

Note Add your items to the master source control server when the other people sharing that database expect the addition of the item.

Warning If other team members are working on the same items as you are, delaying an action to a item may result in conflicting changes later.

Options

Items

Displays the items to add. Click the items you wish to add to the source control server, based on the button you choose (Add now, Remind later, or Do nothing). A check mark appears next to the selected item. These items receive the action of your choice from the buttons (Add now, Remind later, or Do nothing).

Keep Checked Out

Refreshes the source control server with the latest version of the local items that are selected, but keep the item checked out to you.

Comment

Enter any comments about the item here. You can type up to 4,095 characters.

Add Now

Adds the items checked in the Items box. This action pushes the local copy of the added item from the local machine to the source control server so that the contents of the solution will match in both places.

You will be reminded later about adding any unselected items in the Items box (unchecked items).

Remind Later

Delays adding the items to the source control server until you are reminded later. To select specific items to add to the server, click the items to add, then click Add Now.

Push reminders occur when a project is pushed. Push actions are: Check In to Source Control and Add to Source Control. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all the items as they are in both places. This means that the local copy of the item added locally is not added to the source control server. You will not be prompted with any more reminders.

Don’t show push dialog boxes

Suppresses any more instances of the Push Add to Server dialog boxes. You can choose whether the development environment automatically delays the action (reminding you later), or never reminds you at all.

You can enable the dialog boxes again by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

  • Always Remind — Choose this if you would like the development environment to always defer the action and remind you later. This means that if you add items in the development environment, you will not be immediately prompted, and the environment will automatically delay the addition to source control (reminding you later). You will be reminded to complete the action when you do the following push actions: Check In and Add to Source Control.

  • Always do nothing — Choose this if you would like the development environment to do nothing with respect to source control. This means that if you add items in the development environment, you will not be prompted, and the environment will not push the changes to the source control server’s database.


Push Remove to Server Dialog Box

Use this dialog box to control when an item is removed from the source control server. The Items box lists the items that were removed from the local machine. You can remove these items from the source control server or delay the action.

If you delay the removal, the development environment will remind you that there are deleted items that are not pushed to the source control server. You can also choose to do nothing, and keep the items on the source control server.

Note Delete your items in the master source control server when the other people sharing that database expect the deletion of the item.

Warning If other team members are working on the same items as you are, delaying an action to a item may result in conflicting changes later.

Options

Items

Displays the locally deleted items. Click box next to the items you wish to delete on the source control server, based on the button you choose (Add now, Remind later, or Do nothing). A check mark appears next to the selected item.

Remove Now

Deletes the items checked in the Items box. This action deletes the same items on the source control server that were deleted on your local machine, so that the contents of the solution will match in both places.

You will be reminded later about adding any unselected items in the Items box (unchecked items).

Remind Later

Delays deleting the items from the source control server until you are reminded again. To select specific items to remove from the server, click the items to remove, then click Remove Now.

Push reminders occur when a project is pushed. Push actions are: Check In to Source Control and Add to Source Control. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all the items as they are in both places. This means that local copy of the item is not removed in the source control server. You will not be prompted with any more reminders.

Don’t show initial push dialog boxes

Suppresses any more instances of the Push Remove to Server dialog boxes. You can choose whether the development environment automatically delays the action (reminding you later), or never reminds you at all.

You can enable the dialog boxes again by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

  • Always Remind — Choose this if you would like the development environment to always defer the action and remind you later. This means that if you delete items in the development environment, you will not be immediately prompted, and the environment will automatically delay the deletion to source control (reminding you later). You will be reminded to complete the action when you do the following push actions: Check In and Add to Source Control.

  • Always do nothing — Choose this if you would like the development environment to do nothing with respect to source control. This means that if you delete items in the development environment, you will not be prompted, and the environment will not push the changes to the source control server’s database.

Comment

Enter any comments about the item here. You can type up to 4,095 characters.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Push Remove to Server (Incomplete Rename) Dialog Box

Use this dialog box to resolve a situation that is interfering with your removing items. The items you deleted locally were not deleted on the source control server. These deleted items match the items you renamed before (the renaming was local, and the renaming action to source control was deferred).

Instead of renaming the items on the source control server and then deleting them, you can choose to delete them.

The Items box lists the items that you deleted locally. These items were also renamed locally, but the renamed items were not updated on the source control server (the renaming was deferred). The items are listed by their new local names.

If you delay the deletion, the development environment will remind you that there are deleted items that are not pushed to the source control server. You can also choose to do nothing, and keep the items on the source control server.

Note Delete your items in the master source control server when the other people sharing that database expect the deletion of the item.

Warning If other team members are working on the same items as you are, delaying an action to a item may result in conflicting changes later.

Options

Items

Displays the deleted items from the local machine. Click the box next to the items you wish to delete on the source control server, based on the button you choose (Remove now, Remind later, or Do nothing). A check mark appears next to the selected item.

Remove Now

Removes the items checked in the Items box from the source control server. This action ignores the deferred renaming of the items on the source control server and deletes them to match your local machine.

You will be reminded later about removing any unselected items in the Items box (unchecked items).

Remind Later

Delays deleting the items from the source control server until you are reminded. To select specific items to remove from the server, click the specific items to remove, then click Remove Now.

Reminders occur when a project is pushed. Push actions are: Check In to Source Control and Add to Source Control. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all the items as they are in both places. This means that the local copy of the item, removed locally, is not removed in the source control server. You will not be prompted for any more reminders.

Don’t Show Initial Push Dialog boxes

Suppresses any more instances of the Push Remove to Server (Incomplete Rename) dialog boxes. You can choose whether the development environment automatically delays the action (reminding you later), or never reminds you at all.

You can enable the dialog boxes again by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

  • Always Remind — Choose this if you would like the development environment to always defer the action and remind you later. This means that if you delete items in the development environment, you will not be immediately prompted, and the environment will automatically delay the deletion to source control (reminding you later). You will be reminded to complete the action when you do the following push actions: Check In and Add to Source Control.

  • Always do nothing — Choose this if you would like the development environment to do nothing with respect to source control. This means that if you delete items in the development environment, you will not be prompted, and the environment will not push the changes to the source control server’s database.

Comment

Enter any comments about the item here. You can type up to 4,095 characters.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Push Rename to Server Dialog Box

Use this dialog box to control when an item is renamed on the source control server. The Items box lists the items that were renamed on the local machine. You can rename these items on the source control server or delay the action.

If you delay the renaming, the development environment will remind you that there are renamed items that are not pushed to the source control server. You can also choose to do nothing, and keep the items on the source control server with their old names.

Note Rename your items in the master source control server when the other people sharing that database expect the new name of the item.

Warning If other team members are working on the same items as you are, delaying an action to a item may result in conflicting changes later.

Options

Items

Displays the renamed items on the local machine. Click the items you wish to rename on the source control server, based on the button you choose (Add now, Remind later, or Do nothing). A check mark appears next to the selected item.

Rename Now

Renames the items checked in the Items box on the source control server. This action pushes the new name of the item from the local machine to the source control server so that the contents of the solution will match in both places.

You will be reminded later about renaming any unselected items in the Items box (unchecked items).

Remind Later

Delays renaming the items from the source control server until you are reminded again. To select specific items to rename on the server, click the box of the specific items to rename, then click Rename Now.

Reminders occur when a project is pushed. Push actions are: Check In to Source Control and Add to Source Control. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all the items as they are in both places. This means that the local copy of the item, renamed locally, is not renamed on the source control server. You will not be prompted for any more reminders.

Don’t Show Push Reminder Dialog boxes

Suppresses any more instances of the Push Rename to Server dialog boxes. You will not be able to add Comments or use Advanced options until you enable these dialog boxes again.

You can enable the dialog boxes again by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).


Reminder To Push Add To Server Dialog Box

Use this dialog box to control when an item is added to the source control from your local machine. The Items box lists the items that were added to the local machine. You can add these items to the source control server or continue to delay the action.

If you delay the addition, the development environment will continue to remind you that there are added items that are not pushed to the source control server. You can also choose to do nothing, and keep the added items on your local machine only.

Note Add your items to the master source control server when the other people sharing that database expect the addition of the item.

Warning If other team members are working on the same items as you are, delaying an action to a item may result in conflicting changes later.

Options

Items

Displays the added items. Click the box next to the items you wish to add to the source control server, based on the button you choose (Add now, Remind later, or Do nothing). A check mark appears next to the selected item.

Add Now

Adds the items checked in the Items box. This action pushes the local copy of the added item from the local machine to the source control server so that the contents of the solution will match in both places.

You will be reminded later about adding any unselected items in the Items box (unchecked items).

Remind Later

Delays adding the items to the source control server until you are reminded again. To select specific items to add to the server, click the specific items to add, then click Add Now.

Push reminders occur when a project is pushed. Push actions are: Check In to Source Control and Add to Source Control. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all the items as they are in both places. This means that the local copy of the item, added locally, is not added to the source control server. You will not be prompted with any more reminders.

Don’t show push reminder dialog boxes

Suppresses any more instances of the Reminder to Push Add to Server dialog boxes. You can choose whether the development environment automatically delays the action (reminding you later), or never reminds you at all.

You can enable the dialog boxes again by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

  • Always Remind — Choose this if you would like the development environment to always defer the action and remind you later. This means that if you add items in the development environment, you will not be immediately prompted, and the environment will automatically delay the addition to source control (reminding you later). You will be reminded to complete the action when you do the following push actions: Check In and Add to Source Control.

  • Always do nothing — Choose this if you would like the development environment to do nothing with respect to source control. This means that if you add items in the development environment, you will not be prompted, and the environment will not push the changes to the source control server’s database.

Keep Checked Out

Refreshes the source control server with the latest version of the local items that are selected, but keep the item checked out to you.

Comment

Enter any comments about the item here. You can type up to 4,095 characters.


Reminder to Push Remove to Server Dialog Box

Use this dialog box to control when an item is removed from the source control server. The Items box lists the items that were removed from the local machine. You can remove these items from the source control server or continue to delay the action.

If you delay the removal, the development environment will continue to remind you that there are deleted items that are not pushed to the source control server. You can also choose to do nothing, and keep the items on the source control server.

Note Delete your items in the master source control server when the other people sharing that database expect the deletion of the item.

Warning If other team members are working on the same items as you are, delaying an action to a item may result in conflicting changes later.

Options

Items

Displays the locally deleted items. Click the box next to the items you wish to delete on the source control server, based on the button you choose (Add now, Remind later, or Do nothing). A check mark appears next to the selected item.

Remove Now

Deletes the items checked in the Items box. This action deletes the same items on the source control server that were deleted on your local machine, so that the contents of the solution will match in both places.

You will be reminded later about adding any unselected items in the Items box (unchecked items).

Remind Later

Delays deleting the items from the source control server until you are reminded again later. To select specific items to remove from the server, click the specific items to remove, then click Remove Now.

Push reminders occur when a project is pushed. Push actions are: Check In to Source Control and Add to Source Control. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Do Nothing

Leaves all the items as they are in both places. This means that the local copy of the item, removed locally, is not removed in the source control server. You will not be prompted for any more reminders.

Don’t show Push Reminder Dialog boxes

Suppresses any more instances of the Reminder to Push Remove to Server dialog boxes. You can choose whether the development environment automatically delays the action (reminding you later), or never reminds you at all.

You can enable the dialog boxes again by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

  • Always Remind — Choose this if you would like the development environment to always defer the action and remind you later. This means that if you delete items in the development environment, you will not be immediately prompted, and the environment will automatically delay the deletion to source control (reminding you later). You will be reminded to complete the action when you do the following push actions: Check In and Add to Source Control.

  • Always do nothing — Choose this if you would like the development environment to do nothing with respect to source control. This means that if you delete items in the development environment, you will not be prompted, and the environment will not push the changes to the source control server’s database.

Comment

Enter any comments about the item here. You can type up to 4,095 characters.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Reminder to Push Rename to Server Dialog Box

Use this dialog box to control when an item is renamed on the source control server. The Items box lists the items that were renamed on the local machine. You can rename these items on the source control server or continue to delay the action.

If you delay the renaming, the development environment will continue to remind you that there are renamed items that are not pushed to the source control server. You can also choose to do nothing, and keep the items on the source control server with their old names.

Note Rename your items in the master source control server when the other people sharing that database expect the new name of the item.

Warning If other team members are working on the same items as you are, delaying an action to a item may result in conflicting changes later.

Options

Items

Displays the renamed items on the local machine. Click the box next to the items you wish to rename on the source control server, based on the button you choose (Add now, Remind later, or Do nothing). A check mark appears next to the selected item.

Rename now

Renames the items checked in the Items box on the source control server. This action pushes the new name of the item from the local machine to the source control server so that the contents of the solution will match in both places.

You will be reminded later about renaming any unselected items in the Items box (unchecked items).

Remind later

Delays renaming the items from the source control server until you are reminded again. To select specific items to rename on the server, click the specific items to rename, then click Rename Now.

Reminders occur when a project is pushed. Push actions are: Check In to Source Control and Add to Source Control. This is the default setting for reminder dialog boxes. You can change the timing of the dialog boxes by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Do nothing

Leaves all the items as they are in both places. This means that local copy of the item, renamed locally, is not renamed on the source control server. You will not be prompted for any more reminders.

Don’t show initial push dialog boxes

Suppresses any more instances of the Reminder to Push Rename to Server dialog boxes. You will not be able to add Comments or use Advanced options until you enable these dialog boxes again.

You can enable the dialog boxes again by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

  • Always Remind — Choose this if you would like the development environment to always defer the action and remind you later. This means that if you rename items in the development environment, you will not be immediately prompted, and the environment will automatically delay the updated names to source control (reminding you later). You will be reminded to complete the action when you do the following push actions: Check In and Add to Source Control.

  • Always do nothing — Choose this if you would like the development environment to do nothing with respect to source control. This means that if you rename items in the development environment, you will not be prompted, and the environment will not push the changes to the source control server’s database.


Remove Items From Source Control

Use this dialog box to delete an item from source control through the Microsoft development environment. Items marked with a check mark are deleted from the source control server’s database. For best results, remove items through the development environment instead of through the source control program. This allows the development environment to keep a record of the items in your project.

You cannot remove entire projects or entire solutions from the source control database with this dialog box. For details on removing a source control project in the source control program, see your source control documentation.

If you lost a connection to your project or solution in source control because the project or solution was branched, you can reconnect using the Change/Set Connection dialog box.

Options

Items

Displays a list of the items based on your current selection in the Project Explorer (in the development environment). Select the box next to the items you wish to remove from source control and check mark appears next to the item. You can click Check All to select all the items at once.

This box displays the first level of folders and contents; to see additional items contained within sub-folders, click Recurse. Items contained within a sub-folder are not removed from source control unless they are displayed individually in the Items box and selected with a check mark.

Check All

Selects with a check mark all the items visible in the Items box. To see additional subfolders and levels of items, click Recurse. Only items that are visible in the Items box and are shown with a check mark are removed from source control.

Recurse

Forces items to be displayed in sub-folders or sub-directories in the Items box. You can then select these items for source control actions.

By default, the Items box displays only the first level of items contained in the Project Explorer for the development environment. Clicking Recurse displays all the subfolders and all their items for any remaining levels of depth in the directory tree, as shown in the Project Explorer. You can then select additional items for actions in source control.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Rename Item in Source Control Dialog Box

Use this dialog box to rename an item in the source control database. Do not use this dialog box to rename your item in the local project — use the Rename command on the File menu. This dialog box renames items only within the source control server’s database and these changes are not reflected in the local machine.

Options

Current item name

Displays the current name of the item.

New Item name

Sends the rename request to the source control system to be evaluated. Your source control server will supply you with any possible results. This new name changes only in the source control server’s database and is not reflected on your local machine. Name restrictions and limitations are defined by your source code control program.


Set Source Control Connection Dialog Box

Use this dialog box to change the reference location of the source control database/server that you are using. This connection may be interrupted from a project or solution branch on the source control server or from network troubles. You can can point the Microsoft development environment to the new location with the Change/Set Connection button.

You can also use this dialog box to tell the development environment when you are working offline ( not connected to the source control database/server). This can be intentional, from remote work on a laptop, or accidental, from a network connection breaking.

Options

Change Selected Projects to:

  • Work offline — Acknowledges a disconnection from the source control server. Click this if your connection to the source control server is lost or you wish to work remotely. You can change back to working online by using the Set Connection menu command on the Source Control menu item.

  • Work online — Restores your connection with the source control database/server.

Change/Set Connection…

Goes to the Login or Browse dialog box supplied by your source control program.

Apply changes to other projects with similar connections

Applies to your changes here to other projects of a similar source control type. Three basic types of source control databases — for Visual J++, for Visual InterDev, and DataView projects — have different methods of storing information in the source control database. If you have all your projects of the same type, then you can apply the changes made here to the rest of the projects.


Source Control (Environment - Options Dialog Box)

Tasks Related Topics

Use this dialog box to customize your interface with source control. You can set source control dialog boxes to appear, appear only in specific cases, or disappear. You can set up default behaviors to fit your work style; such as setting the development environment to automatically update all the items by getting the latest version of all the items associated with a solution (when you open that solution).

You can change some options in the dialog boxes themselves. You can enable dialog boxes again by changing options here.

Options

Get everything when opening a solution

Sets the development environment to Get all items associated with a solution every time you open that solution. You can disable the Get Latest Version dialog box by selecting the Don’t show this dialog box again check box on the dialog box itself.

Check in everything when closing the solution

Sets the development environment to check in all items associated with a solution every time you close that solution. You can disable the Check In Items dialog box by either selecting the Don’t show this dialog box again check box on the dialog box. You can enable this dialog box again by selecting the Show detail dialog boxes (Check In) check box on this Options page.

Perform background status updates

Sets the development environment to retrieve source control information from the master database when items are updated. This option is only available for other source control programs (not available in Visual SourceSafe).

Add new projects to source control

Sets the development environment to automatically enable the Add to Source Control dialog box when you add a new project to a solution. The Add to Source Control dialog box can be disabled by either selecting the Don’t show this dialog box again button on the dialog box, or by selecting the After item add, remove or rename check box on this page.

When checked in items are edited

Sets the preferred default behavior of the development environment when you are editing an item that is not checked out from source control (and is therefore read-only).

  • Check Out — Checks out all items every time you start to edit an item. The development environment beeps when the item is checked out of source control. You may lose a keystroke while this action is performed. The editor may change to adapt to the new status of the item.

  • Prompt — Causes the Check Out Items dialog box to appear every time you start to edit an item. With the dialog box enabled, you can set Advanced options and add Comments.

  • Do Nothing — Disables all source control dialog boxes. The development environment does nothing when you edit an item that is not checked out. Your changes will only be on your local machine.

After item add, remove or rename

Sets the preferred default behavior of the development environment when you are adding an item, removing an item or renaming an item locally. Typically, the development environment will prompt you to reflect these changes in the source control database. You can defer these changes with reminders or do nothing.

You can set the default to:

  • Prompt — Shows the appropriate dialog box for that action (Add to Source Control, Remove from Source Control, or Rename).

  • Remind later — Defers the action from the source control database, and triggers reminder dialog boxes about the deferred items. This keeps all the added items, removed items, and renamed items local (changes are not reflected in the source control database).

  • Do nothing — Disables all dialog boxes and reminders. Sets the default behavior to no dialog boxes when these actions occur. These changes will remain local and are not reflected in the source control database.

Show pull reminders

Enables pull reminder dialog boxes according to the frequency setting you choose.

Pull actions are changes retrieved from the source control server to the local machine. Pull actions include Get Latest, Check Out, and Undo Check Out. Pull reminder dialog boxes prompt you to synchronize the source control server and your local machine so that the same versions of the items exist in both places. Reminder dialog boxes can perform the action, delay the action until later, or skip the action entirely.

  • On every pull — Shows the reminder dialog boxes every time you perform a pull action (Get Latest, Check Out, or Undo Check Out) on any item in the Project Explorer.

  • On project pull — Shows the reminder dialog boxes when you perform a pull action (Get Latest, Check Out, or Undo Check Out) only on a project in the Project Explorer. This is the default setting.

  • Never — Disables the pull reminder dialog boxes.

Show push reminders

Enables push reminder dialog boxes according to the frequency setting you choose.

Push actions are changes sent to the source control server from the local machine. Push actions include Check In and Add to Source Control. Push reminder dialog boxes prompt you to synchronize the source control server and the local machine so that the same versions of the items exist in both places. Reminder dialog boxes can perform the action, delay the action until later, or skip the action entirely.

  • On every push — Shows the reminder dialog boxes every time you perform a push action (Check In or Add to Source Control) on any item in the Project Explorer.

  • On project push — Shows the reminder dialog boxes when you perform a push action (Check In or Add to Source Control) only on a project in the Project Explorer. This is the default setting.

  • Never — Disables the push reminder dialog boxes.

Show detail dialog boxes for

Enables or disables the source control integration dialog boxes. Click the check box appropriate to show the detail dialog box during the source control action. There are dialog boxes for: Check Out, Check In, Get Latest Version, Undo Check Out and Add to Source Control.

For example, when you check an item into source control, you will see the Check In Items dialog box. On this dialog box you can select the Don’t show this dialog box again check box to disable the Check In Items dialog box. When you next check in an item, you will not be prompted by the dialog box you disabled. While this technique is useful for repetitive actions, you cannot fill in comments or click any advanced source control options (if available) when the dialog boxes are not enabled. Click on the name of the dialog box here to enable these detailed dialog boxes again.

Include only selected items in dialog boxes

Controls the amount of information that appears in the Items listing of the source control dialog boxes. The default is that only selected items (or all the items in a selected solution) will appear in the Items box. You can expand that listing with the Recurse check box on the dialog box in question, or change this option.

Login

Enters your name here for logging into the source control database server. If supported by your source control provider, this name will be filled in automatically in the Login dialog box to reach your source control server.

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.


Specify Working Directory Dialog Box

Use this dialog box to fix a situation, in this case a single item added into a directory level above the project directory, so that the source control copy of the project directory may inherit additional items and duplicate them in unexpected places.

Options

Project

Displays the current directory that the specific project was added to.

Working Directory

Displays a suggested working directory. To change the working directory entry, type the desired path or click Browse to select it.

If you change the suggested working directory, you should choose the new path carefully. The definition of the working directory and the best choice for its location depend on the source control provider you are using.

For example, if you are using Visual SourceSafe, the root working directory for a source control project should be at or above the level of all the items you intend to add to the source control project. Suppose your project contains include or header files that do not reside within or below the folder containing the project file. The related source control project should have a working directory that contains all of these items within its nested subdirectories.


Undo Check Out Dialog Box

Tasks Related Topics

Use this dialog box to undo a check out of a solution, project, or individual item from source control. Items marked with a check mark in the Items box are returned to the state they were in before you checked them out.

Undoing a check out returns the item to read-only status in source control. No changes are saved to the source control database. The item returns to its condition and version before you checked it out.

Options

Items

Displays a list of the items based on your current selection in the Project Explorer (in the development environment). Select the box next to the items you wish to undo. A check mark appears next to the item. You can click Check All to select all the items at once.

This box displays the first level of folders and contents; to see additional items contained within sub-folders, click Recurse. Items contained within a sub-folder are not undone for their check out unless they are displayed individually in the Items box and selected with a check mark.

Check All

Selects with a check mark all the items visible in the Items box. To see additional subfolders and levels of items, click Recurse. Only items that are visible in the Items box and are shown with a check mark are affected by your action in this dialog box.

Recurse

Forces items to be displayed in sub-folders or sub-directories in the Items box. You can then select these items for source control actions.

By default, the Items box displays only the first level of items contained in the Project Explorer for the development environment. Clicking Recurse displays all the subfolders and all their items for any remaining levels of depth in the directory tree, as shown in the Project Explorer. You can then select additional items for actions in source control.

Don’t show this dialog box again

Suppresses any more instances of the Undo Check Out dialog boxes. Undo Check Out becomes a direct command on the environment menus. You will not be able to add Comments or use Advanced options until you enable these dialog boxes again.

You can enable the dialog boxes again by changing the options listed in the Source Control page (from the Tools menu, select Options, then expand the Environment node and click the Source Control node).

Advanced

Displays more options on adding items to source control. Your source control program supplies these options.